
package de.ivu.elect.presentation.email;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.email.boundary.EmailVorlageBoundaryCreate;
import de.ivu.elect.business.email.entity.EmailVorlage;
import de.ivu.elect.business.email.entity.EmailVorlageMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractEmailVorlageCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractEmailVorlageCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.EMAIL_VORLAGE_CREATE)
public abstract class AbstractEmailVorlageCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<EmailVorlage> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailVorlageCreateView";

  public static final String VIEW_ID = "/email/email-vorlage-create.xhtml";

  public static final String PARENT_VIEW_ID = "/email/email-vorlage-search.xhtml";

  @Inject
  protected transient EmailVorlageBoundaryCreate create;

  protected EmailVorlage entity;

  @Inject
  protected transient EmailVorlageMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  EmailVorlage());
  }

  

  public EmailVorlage getEntity() {
    return entity;
  }

  protected void setEntity(EmailVorlage entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_VORLAGE_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(EmailVorlage entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(EmailVorlage entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.EMAIL_VORLAGE_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
